#include <string>
#include "varset.h"
using namespace std;

VarSet UniverseVarSet;
VarSet EmptyVarSet;

ostream& operator<<(ostream &out, const VarSet &d) {
  d.Print(out, 0);
  return(out);
}

int keycompare(string s1, string s2) {
	return s1.compare(s2);
}

void VarSetInit() {
  string s;
  for (int i = 0; i < 26; i++) {
    s = 'a' + i;
    UniverseVarSet = UniverseVarSet.Insert(s,true);
  }
} /** end of VarSetInit **/

bool Eq(VarSet x, VarSet y)
{
  VarSet ans;
  bool temp;

  VarSet::iterator *beg;
  for (beg = x.First(); beg; beg = beg->Next()) {
    if (y.Lookup(beg->Key(), temp) == NOT_FOUND) {
      return false;
    }
  }
  for (beg = y.First(); beg; beg = beg->Next()) {
    if (x.Lookup(beg->Key(), temp) == NOT_FOUND) {
      return false;
    }
  }
  return true;
}

VarSet Diff(VarSet x, VarSet y)
{
  VarSet ans = x;

  VarSet::iterator *beg;
  for (beg = y.First(); beg; beg = beg->Next()) {
    ans = ans.Delete(beg->Key());
  }
  return ans;
} /** end of Diff **/

VarSet Union(VarSet x, VarSet y)
{
  VarSet ans = x;

  VarSet::iterator *beg;
  for (beg = y.First(); beg; beg = beg->Next()) {
    ans = ans.Insert(beg->Key(),beg->Datum());
  }
  return ans;
} /** end of Union **/

VarSet Intersect(VarSet x, VarSet y)
{
  VarSet ans;
  bool temp;

  VarSet::iterator *beg;
  for (beg = x.First(); beg; beg = beg->Next()) {
    if (y.Lookup(beg->Key(), temp) == FOUND) {
      ans = ans.Insert(beg->Key(),temp);
    }
  }
  return ans;
} /** end of Intersect **/

VarSet mkVarSet(string s)
{
  VarSet ans;
  ans = ans.Insert(s,true);
  return ans;
}

VarSet mkVarSet(string s1, string s2)
{
  VarSet ans;
  ans = ans.Insert(s1,true);
  ans = ans.Insert(s2,true);
  return ans;
}

VarSet mkVarSet(string s1, string s2, string s3)
{
  VarSet ans;
  ans = ans.Insert(s1,true);
  ans = ans.Insert(s2,true);
  ans = ans.Insert(s3,true);
  return ans;
}

VarSet mkVarSet(string s1, string s2, string s3, string s4)
{
  VarSet ans;
  ans = ans.Insert(s1,true);
  ans = ans.Insert(s2,true);
  ans = ans.Insert(s3,true);
  ans = ans.Insert(s4,true);
  return ans;
}
